<?php

if (defined('XASECO_VERSION')){
	define('USE_XASECO', true);
} else {
	define('USE_XASECO', false);
}

global $googletr;
$googletr = new GoogleTranslate();	




class GoogleTranslate {

	var $Aseco;
	private $config;
	private $chatlog = array();
	public $players;
	

function startUp() {
	if (USE_XASECO) {
	global $aseco; 
	$this->Aseco = $aseco;
	}
	$this->config = array();
	$this->config['version'] = "1.21";
	$this->config['brand'] ='$o$46eG$d13o$fa0o$46eg$3a1l$d13e $n$4ceTranslate $z$s$fff|';
	$xml = simplexml_load_file("google_translate.xml");
	$this->config['key'] = strval($xml->key);
	$this->config['site'] = strval($xml->site);
		if (!isset($xml->key) && !isset($xm�->site)) {	
			  trigger_error('[Google Translate] Could not read/parse setttings file google_translate.xml!', E_USER_WARNING);
			  return false;
		  }	
	$this->config['enabled'] = true;
}

function isAdmin($login){
		if (USE_XASECO){
			$player = $this->Aseco->server->players->getPlayer($login);
			return $this->Aseco->isAnyAdmin($player);
		}else {
			return verifyAdmin($login);
		}
		return false;
}

function addCall($method, $args){
		if (USE_XASECO) {
			$this->Aseco->addCall($method, $args);
		} else {
			addCallArray(null, array_merge(array($method), $args));
		}
}


function sendChat($message, $login=''){
		if ($login){
			$this->addCall('ChatSendServerMessageToLogin', array($message, $login));
		} else {
			$this->addCall('ChatSendServerMessage', array($message));
		}
	}
	
function execQuery($call, $args){
		if (USE_XASECO){
		$this->Aseco->client->query($call, $args);
		$result = $this->Aseco->client->getResponse();
		} else {
		global $_client;
		$_client->query($call,$args);
		$result = $_client->getResponse();		
		}
		return $result;
	}



function playerDisconnect($login) {
	unset($this->players[$login]);
	unset($this->autotranslate[$login]);
}


function playerConnect($login) {
	$translate = $this->config['brand'];
	$version = $this->config['version'];
	
	$this->players[$login]['login'] = $login;
	if ($this->getClientDetails($login)) {
	$this->sendChat("$translate usage:",$login);
	$this->sendChat("$translate /translate your text in any language here|language",$login);
	$this->sendChat("$translate /translate ich liebe trackmania|en",$login);
	$this->sendChat("$translate will translate german to english",$login);
	}
} 

function processChat($login, $chat) {
	$target = $this->autotranslate[$login]['target'];
	$ip = $this->players[$login]['ip'];
    $this->translate($chat,$target,$ip,$login);  // translate!
}

function logchat($login, $chat) {

	array_push($this->chatlog, array("stamp" => time(), "login" => $login, "nick" => $this->players[$login]['nickname'], "chat" => $chat));

	if ( count($this->chatlog) > 500) {
		$this->chatlog = array_slice($this->chatlog, (count($this->chatlog) - 500), 500);
	}

	}

function translateLog($login, $chat, $nick, $lang = "en") {
$ip = $this->players[$login]['ip'];
	$message = '$4ce>> Chatlog:$fff '.$chat;
	$this->sendChat($message, $login);
	$this->translate($chat,$lang,$ip,$login,$login);
}

function command_translate($login, $chat) {
	$translate = $this->config['brand'];
	$params = explode("|",$chat);
	
	$chat = trim($params[0]);
	if ($chat == "on") {
		if ($this->isAdmin($login)) {
		$this->config['enabled'] = true;
		$message = "$translate Admin has enabled the translate service.";
		$this->sendChat($message);
		return;
		}
	}
	if ($chat == "off") {
			if ($this->isAdmin($login)) {
		$this->config['enabled'] = false;
		$message = "$translate Admin has disabled the translate service.";
		$this->sendChat($message);
		return;
		}

	}
	
	if ($this->isAdmin($login)) {
	$command = trim($params[1]);
		if (!empty($command) && $command == "on") {
			if (isset($this->players[$chat]['login'])) {
				$this->players[$chat]['enabled'] = true;
				$message = "$translate Admin has enabled translate for ".$this->players[$chat]['nickname'] ;
				$this->sendChat($message);
				return;
			}
		}
		
		if (!empty($command) && $command == "off") {
			if (isset($this->players[$chat]['login'])) {
				$this->players[$chat]['enabled'] = false;
				$message = "$translate Admin has disabled translate for ".$this->players[$chat]['nickname'] ;
				$this->sendChat($message);
				return;
			}
		}
	
	 
	}
	$target = $this->checkLang(trim($params[1]));
	if ($target == false || empty($target)) {
	$target = "en";
	}
	$ip = $this->players[$login]['ip'];
	$message = '$ff0['.$this->players[$login]['nickname'].'$z$s] $ff0'.$chat;
	$this->sendChat($message);
	$this->translate($chat,$target,$ip,$login);
}

function command_autotranslate($login, $chat) {
	$translate = $this->config['brand'];

	if (empty($chat)) {
		$message = "$translate usage /autotranslate [target lang] or /autotranslate off";
		$this->sendChat($message,$login);
		return;
	}
	
	if ($this->isAdmin($login)) {
		$params = explode("|",$chat);
			if (count($params) == 1 ) {
				if ($chat == "off") {
				unset($this->autotranslate[$login]);
				$message = "$translate AutoTranslate disabled for you.";
				$this->sendChat($message);
				return;
				}
				
				$target_lang = $this->checkLang($chat);
				if ($target_lang === false) {
						$message = "$translate Target language not found. Autotranslate not set.";
						$this->sendChat($message,$login);
						return;
				} 
				$this->autotranslate[$login]['login'] = $login;
				$this->autotranslate[$login]['target'] = $target_lang;
				$message = "$translate Autotranslate set for you to $target_lang.";
				$this->sendChat($message,$login);
				return;
			}
	
		$target_login = $params[0];
		if (!isset($this->players[$target_login])) {
				$message = "$translate target player not found. Autotranslate not set.";
				$this->sendChat($message,$login);
				return;
		}
		
		$target_lang = $params[1];
		if ($target_lang == "off") {
				$message = "$translate Admin disabled Autotranslate for player ".$target_login;
				$this->sendChat($message);
				unset($this->autotranslate[$target_login]);
				return;
		}
		$target_lang = $this->checkLang($params[1]);
		
		if ($target_lang === false) {
				$message = "$translate Target language not found. Autotranslate not set.";
				$this->sendChat($message,$login); 
				return;
		} 
		
		 // if all conditions are set, enable autotranslate for player
		$this->autotranslate[$target_login]['login'] = $target_login;
		$this->autotranslate[$target_login]['target'] = $target_lang;
		$message = "$translate Admin set Autotranslate set for ".$target_login;
		$this->sendChat($message); 
		return;
		
	} else {
	
	if ($chat == "off") {
				unset($this->autotranslate[$login]);
				$message = "$translate AutoTranslate disabled.";
				$this->sendChat($message,$login); 
				return;
				}
				
				$target_lang = $this->checkLang($chat);
				if ($target_lang === false) {
						$message = "$translate Target language not found. Autotranslate not set.";
						$this->sendChat($message,$login); 
						return;
				} 
				$this->autotranslate[$login]['login'] = $login;
				$this->autotranslate[$login]['target'] = $target_lang;
				$message = "$translate Autotranslate set for you to $target_lang.";
				$this->sendChat($message,$login);
				return;
	}
}


function getClientDetails($login) {
		$info = $this->execQuery('GetDetailedPlayerInfo', $login);
		$ip = $info['IPAddress'];
		$nick = $info['NickName'];
		if (empty($ip)) { // if info not found, exit
			$message = "$translate Error fetching player data from tm trying again...";
			$this->sendChat($message,$login);
			
			$info = $this->execQuery('GetPlayerInfo', $login);
			$nick = $info['NickName'];
			if (empty($nick)) { // if info not found, exit
			$message = "$translate Another try, and no data, translating disabled!";
			$this->sendChat($message,$login);
			$this->players[$login]['enabled'] = false;
			return false;
			} 
		}
		else {
		$this->players[$login]['ip'] = $ip;
		$this->players[$login]['nickname'] = $nick;
		$this->players[$login]['enabled'] = true;
		}
		return true;
}

function checkLang($lang) {
 $support = array('afrikaans' => 'af',
  'albanian' => 'sq',
  'amharic' => 'am',
  'arabic' => 'ar',
  'armenian' => 'hy',
  'azerbaijani' => 'az',
  'basque' => 'eu',
  'belarusian' => 'be',
  'bengali' => 'bn',
  'bihari' => 'bh',
  'breton' => 'br',
  'bulgarian' => 'bg',
  'burmese' => 'my',
  'catalan' => 'ca',
  'cherokee' => 'chr',
  'chinese' => 'zh',
  'chinese_simplified' => 'zh-cn',
  'chinese_traditional' => 'zh-tw',
  'corsican' => 'co',
  'croatian' => 'hr',
  'czech' => 'cs',
  'danish' => 'da',
  'dhivehi' => 'dv',
  'dutch'=> 'nl',  
  'english' => 'en',
  'esperanto' => 'eo',
  'estonian' => 'et',
  'faroese' => 'fo',
  'filipino' => 'tl',
  'finnish' => 'fi',
  'french' => 'fr',
  'frisian' => 'fy',
  'galician' => 'gl',
  'georgian' => 'ka',
  'german' => 'de',
  'greek' => 'el',
  'gujarati' => 'gu',
  'haitian_creole' => 'ht',
  'hebrew' => 'iw',
  'hindi' => 'hi',
  'hungarian' => 'hu',
  'icelandic' => 'is',
  'indonesian' => 'id',
  'inuktitut' => 'iu',
  'irish' => 'ga',
  'italian' => 'it',
  'japanese' => 'ja',
  'javanese' => 'jw',
  'kannada' => 'kn',
  'kazakh' => 'kk',
  'khmer' => 'km',
  'korean' => 'ko',
  'kurdish'=> 'ku',
  'kyrgyz'=> 'ky',
  'lao' => 'lo',
  'latin' => 'la',
  'latvian' => 'lv',
  'lithuanian' => 'lt',
  'luxembourgish' => 'lb',
  'macedonian' => 'mk',
  'malay' => 'ms',
  'malayalam' => 'ml',
  'maltese' => 'mt',
  'maori' => 'mi',
  'marathi' => 'mr',
  'mongolian' => 'mn',
  'nepali' => 'ne',
  'norwegian' => 'no',
  'occitan' => 'oc',
  'oriya' => 'or',
  'pashto' => 'ps',
  'persian' => 'fa',
  'polish' => 'pl',
  'portuguese' => 'pt',
  'portuguese_portugal' => 'pt-pt',
  'punjabi' => 'pa',
  'quechua' => 'qu',
  'romanian' => 'ro',
  'russian' => 'ru',
  'sanskrit' => 'sa',
  'scots_gaelic' => 'gd',
  'serbian' => 'sr',
  'sindhi' => 'sd',
  'sinhalese' => 'si',
  'slovak' => 'sk',
  'slovenian' => 'sl',
  'spanish' => 'es',
  'sundanese' => 'su',
  'swahili' => 'sw',
  'swedish' => 'sv',
  'syriac' => 'syr',
  'tajik' => 'tg',
  'tamil' => 'ta',
  'tatar' => 'tt',
  'telugu' => 'te',
  'thai' => 'th',
  'tibetan' => 'bo',
  'tonga' => 'to',
  'turkish' => 'tr',
  'ukrainian' => 'uk',
  'urdu' => 'ur',
  'uzbek' => 'uz',
  'uighur' => 'ug',
  'vietnamese' => 'vi',
  'welsh' => 'cy',
  'yiddish' => 'yi',
  'yoruba' => 'yo'
  );
  
	foreach ($support as $long => $short) {
		if ($lang == $long || $lang == $short) return $short;
	}
	
	return 'en';
}

function translate($text, $lang, $ip,$login, $tologin = false) {
	if ($tologin != false) {
		if ($this->players[$tologin]['enabled'] == false) {
			$message = "$translate is disabled for you.";
			$this->sendChat($message,$tologin);
			return;
		}
	}
	else {
		if ($this->config['enabled'] == false) {
			$message = "$translate Translate service is turned off.";
			$this->sendChat($message,$login);	
			return;
			}
		if ($this->players[$login]['enabled'] == false) {
			$message = "$translate Translate service is turned for you.";
			$this->sendChat($message,$login);	
			return;
			}
		}
	$translate = $this->config['brand'];
	$extip = explode(":",$ip);
	$ip = $extip[0];
	if (empty($lang)) $lang = "en";
	$query = rawurlencode($text);
	$url = "https://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q=".$query."&langpair=%7C".$lang."&key=".$this->config['key']."&userip=".$ip;
	// sendRequest
	$ch = curl_init($url);
	//curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_SSLVERSION,3); 
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_REFERER, $this->config['site'] );
	$body = curl_exec($ch);
	if( $body === false)
	{
		$message = 'Translate Curl error: ' . curl_error($ch);
		$this->sendChat($message);
	}
	curl_close($ch);
	 
	 
	// process the JSON string
	$return = json_decode($body);
	
	
	if (isset($return->responseData->translatedText)) 
	$output = html_entity_decode($return->responseData->translatedText, ENT_QUOTES);
	else 
	$output = '$f00 error: '. html_entity_decode($return->responseDetails, ENT_QUOTES);
	$message = "$translate $output";
		if ($tologin != false) {
			$this->sendChat($message,$tologin);
		} else {
			$this->sendChat($message);
		}
}

function xaseco_chatlog_ml($login) {

	$player = $this->Aseco->server->players->getPlayer($login);
	$this->Aseco->server->players->player_list[$login]->playerlist = array();  // unset playerlist object
		
		$head = 'Translate Chatlog:';
		$msg = array();
		$msg[] = array('Time', 'Nick/Login', 'Chat');
		$pid = 1;
		$lines = 0;
		$player->msgs = array();
		$player->msgs[0] = array(1, $head, array(1.5, 0.1, 0.3, 0.9), array('Icons128x128_1', 'Buddies'));
		// create list of players, optionally by (sub)string
		$chatlog = array_reverse($this->chatlog);
		foreach ($chatlog as $data) {

				$array = array();
				$array['nick'] = $data['nick'];
				$array['chat'] = $data['chat'];
				$this->Aseco->server->players->player_list[$login]->playerlist[] = $array;   // fill playerlist object
				
				// format nickname & login
				$ply = $data['nick']."/".$data['login'];
				$time = date("H:s",$data['stamp']);
				// add clickable button
				//$chat = $data['chat'];
				if ($this->Aseco->settings['clickable_lists'] && $pid <= 200)
					$chat = array($data['chat'], $pid+9200);  // action id

		
				$msg[] = array($time,$ply, $chat);
				$pid++;
				if (++$lines > 14) {
					$player->msgs[] = $msg;
					$lines = 0;
					$msg = array();
					$msg[] =array('Time', 'Nick/Login', 'Chat');
				}
			}
		
		// add if last batch exists
		if (count($msg) > 1)
			$player->msgs[] = $msg;

		// display ManiaLink message
		if (count($player->msgs) > 1) {
			display_manialink_multi($player);
		} else {  // == 1
			$this->Aseco->client->query('ChatSendServerMessageToLogin', "No Data to show", $login);
		}
	}

} // END OF CLASS

	function gtr_Connect($aseco, $command){
		global $googletr;
		$googletr->playerConnect($command->login);
	}
	
	function gtr_Disconnect($aseco, $command){
		global $googletr;
		$googletr->playerDisconnect($command->login);
	}
	
	function gtr_startUp($aseco, $command){
		global $googletr;
		$googletr->startUp();
	}
	
	function gtr_onChat($aseco, $command) {
    global $googletr;
	$login = $command[1];
	$chat = trim($command[2]);
	if ($command[0] == $aseco->server->id) return;
    if ($command[2]{0} == '/') return;
	$googletr->logchat($login,$chat);
	if (strlen($chat) < 4) return; // if chat text is too short, exit
	if (!isset ($googletr->autotranslate[$login]['login'])) return; // if autotranslate isnt set, exit	
	$googletr->processChat($login, $chat);
	}
	
	function gtr_event($aseco, $answer) {
	global $googletr;
	if ($answer[2] >= 9201 && $answer[2] <= 9400) {
		$login = $answer[1];
		$player = $aseco->server->players->getPlayer($answer[1]);
		
		$chatdata = $player->playerlist[$answer[2]-9201];
		$lang = $googletr->players[$login]['lang'];
		if (empty($lang)) $lang = "en";
		$chat = $chatdata['chat'];
		$nick = $chatdata['nick'];
		$googletr->translateLog($login,$chat,$nick,$lang);
	}
	
	}


if (USE_XASECO) {
Aseco::RegisterEvent("onPlayerConnect", "gtr_Connect");
Aseco::RegisterEvent("onPlayerDisconnect", "gtr_Disconnect");
Aseco::RegisterEvent("onStartup", "gtr_startUp");
Aseco::RegisterEvent("onChat", "gtr_onChat");
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'gtr_event');
Aseco::addChatCommand('translate', 'Translate text, Powered by Google');
Aseco::addChatCommand('autotranslate', 'AutoTranslate text, Powered by Google');
Aseco::addChatCommand('logtranslate', 'Translate chatlog');

	function chat_translate($aseco, $command) {
	global $googletr;
	$player = $command['author']; 
	$chat = $command['params']; 
	$login = $player->login;
	$googletr->command_translate($login, $chat);
	}
	
	function chat_autotranslate($aseco, $command) {
	global $googletr;
	$player = $command['author']; 
	$chat = $command['params']; 
	$login = $player->login;
	$googletr->command_autotranslate($login, $chat);
	}
	
	function chat_logtranslate($aseco, $command) {
	global $googletr;
	$player = $command['author']; 
	$chat = $command['params'];
	
	$target = $googletr->checkLang(trim($chat));
	if ($target == false || empty($target)) {
	$target = "en";
	}
	$login = $player->login;
	$googletr->players[$login]['lang'] = $target;
	$googletr->xaseco_chatlog_ml($login);
	}
	
} else {

	registerPlugin('gtrans',50);
	registerCommand('translate', 'Translate text, Powered by Google');
	registerCommand('autotranslate', 'Autotranslate text, Powered by Google');

	function chat_translate($author, $login, $params){
		global $googletr;
		$params = implode(" ",$params);
		$googletr->command_translate($login, $params);
	}
	
	function chat_autotranslate($author, $login, $params){
		global $googletr;
		$params = implode(" ",$params);
		$googletr->command_autotranslate($login,$params);
	}
}

	function gtransPlayerConnect($event,$login){
		global $googletr;
		$googletr->playerConnect($login);
		
	}
	
	function gtransPlayerDisconnect($event,$login){
		global $googletr;
		$googletr->playerDisconnect($login);
	}
	
	function gtransStartToServe($event){
		global $googletr;
		$googletr->startUp();

	}
		
	function gtransPlayerChat($event,$login,$message,$iscommand){
	global $googletr;
	if ($iscommand) return; // if its a command exit
	$googletr->logchat($login,$message);
	if (strlen($message) < 4) return; // if chat text is too short, exit
	if (!isset ($googletr->autotranslate[$login]['login'])) return; // if autotranslate isnt set, exit	
	$googletr->processChat($login, $message);
	}
	
	


?>